///////////////////////////////////////////////////////////////////
//Aufgabe 6 Kapitel Turtlegrafik
///////////////////////////////////////////////////////////////////

// Zustand der Turtle
boolean penIsDown; // Stift is unten (es wird gemalt)

// gloable Variablen: 
// Fenstergröße
int w=800;
int h=800;
float laenge = 100;
float delta = 90;
int tiefe = 1;
int farbe = 0;

// die Beschreibungssprache

String axiom = "L";
String substitut_L = "+LF-LFL-FL+";
String substitut_R = "-RF+RFR+FR-";
String s = axiom;

///////////////////////////////////////////////////////////

void settings() {
  size(w, h);
}

void setup() {
  colorMode(HSB,256);
  ersetzeBuchstaben();
  noLoop();
  redraw();
}

///////////////////////////////////////////////////////////
// Erzeuge eine Zeichenkette, die die Schneeflocke 
// beschreibt. Hierbei werden von "axiom" aufgehend
// alle "F" in der Zeichenkette durch "substitut" ersetzt
///////////////////////////////////////////////////////////

void ersetzeBuchstaben() {
  
  s = axiom;
  // ersetze alle "L" und "R" in s durch die Substitute
  for (int i=0; i<tiefe; i++) {
    String s1 = "";
    for (int k=0; k<s.length(); k++) {
      if (s.charAt(k)=='L') s1 = s1 + substitut_L; else  
        if (s.charAt(k)=='R') s1 = s1 + substitut_R; else
          s1 = s1 + s.charAt(k);
    }
    s = s1;
    println(s);
  }
}

///////////////////////////////////////////////////////////

void draw() {
  background(255);
  translate(width/4+20,2*height/3); 
  strokeWeight(2);

  penDown();
  laenge = (0.45*width)/pow(2, tiefe);

  // jetzt interpretiere die mit "applySubstitutions()"
  // erzeugte Zeichenkette
  
  for (int i=0;i<s.length();i++) {
    char c = s.charAt(i);
    switch (c) {
      case 'F': move(laenge);
               
                break;
      case '+': turn(delta);
                break;
      case '-': turn(-delta);
                break;
    }  
  } 
}

///////////////////////////////////////////////////////////

void keyPressed() {
  if (key == '+') {
      tiefe = min(10,tiefe+1);
      ersetzeBuchstaben();
      redraw();
  }
  if (key == '-') {
      tiefe = max(1,tiefe-1);
      ersetzeBuchstaben();
      redraw();
  }
}

///////////////////////////////////////////////////////////
//
// Turtle Kommandos
//
///////////////////////////////////////////////////////////

void move(float len) {
  if (penIsDown){setColor(color(farbe,255,255)); line(0,0,len,0);farbe = (farbe +20)%256; }
  // bewege Turtle weiter
  translate(len,0);
}

void turn(float ang) { rotate(radians(-ang)); }
void setColor(color c) { strokeWeight(2);stroke(c); }
void penUp() { penIsDown = false; }
void penDown() { penIsDown = true; }